# File: Zope-2.2.5.spec
#
# Digicool Z-Object Programming Environment (ZOPE)
#
#   "Zope is an Open Source application server and portal
#    toolkit used for building high-performance, dynamic Web sites."
#
# An independent 'BuildRoot:' directive is used so that that this package
# can be built in the /var/tmp directory, for the case where the existing
# software on the build host would be disrupted by installing-after-build-
# to-package onto that system.
#
# Sample Package Names:
#   Zope-2.2.2-1.i386.rpm
#
# NOTE to Future ZOPE RPM Maintainers:
#
# The Zope tarball contains many subsystems, some dependent on Zope and
# some that can be used independently.  The independent ones have been
# placed into the common /usr/lib/python1.5/site-packages/ directory tree
# while for the others, I've created a new directory:
#
#     /usr/share/zope/
#
# The contents of that directory is -not- a Python Package such that
# anyone must "import blah".  Rather, it is directly imported by the Zope
# software.  This does mean naming collisions are possible with non-Zope
# packages such as PIL and mxDateTime, but until Zope is reorganized into
# a true Python Package layout, this cannot be helped.
#
# The /usr/share/zope/ hierarchy is read-only, while the /var/zope/ one is
# basically read-write, in keeping with the Linux Filesystem Standard.
#
####

# To-Be-Done-Perhaps:
#o get working seamlessly with ZPatterns
#o word to make compatible with other distributions: RH 6.2 and RH 7.0 (no rc.d) and Caldera, etc.
#o add ZServer-fastcgi sub-RPM

####
# Section: Preamble (Items Displayed When Users Request Info About Package)
#
# The order of the entries below is unimportant.
#
####

Name:               Zope
Version:            2.2.5
Release:            8
Copyright:          Zope Public License (ZPL)
URL:                http://www.zope.org/
Packager:           Jeff Rush <jrush@taupro.com>
BuildRoot:          %{_tmppath}/Zope-%{version}-rootdir
Prereq:             python python-devel /sbin/chkconfig /usr/sbin/useradd

Source0: http://www.zope.org/Download/Releases/Zope-%{version}/Zope-%{version}-src.tgz
Source1: http://www.zope.org/Documentation/Guides/ZCMG/ZCMG.html.tgz
Source2: http://www.zope.org/Documentation/Guides/DTML/DTML.html.tgz
Source3: http://www.zope.org/Documentation/Guides/ZSQL/ZSQL.html.tgz
Source4: http://www.zope.org/Documentation/Guides/Zope-ProductTutorial.tar.gz
Source5: Zope-%{version}-zope
Source6: Zope-%{version}-Zope.cgi
Source7: Zope-%{version}-README.RPM
Source8: Zope-%{version}-zserver-wo-pcgi.sh
Source9: Zope-%{version}-zserver-w-pcgi.sh
Source10: http://www.zope.org/Documentation/Guides/ZDG/ZDG.html.tgz
Source11: http://www.zope.org/Documentation/Guides/ZAG/ZAG.html.tgz
Source12: Zope-%{version}-pcgi_nullpublisher.py
Source13: SiteAccess-2.0.0b3-nonbin.tgz
Source14: Zope-%{version}-index.html
Source15: Hotfix_2001-02-23.tgz
#NOTWORKING Source15: ZPatterns-0-4-0a3.tgz
#Source16: Hotfix_2000-10-02.tar.gz
#Source17: Hotfix_2000-10-11.tgz
#Source18: Hotfix_2000-12-08.tgz
#Source19: Hotfix_2000-12-15a.tgz
#Source20: Hotfix_2000-12-18.tgz
Source21: Hotfix_2001-05-01.tgz
Source22: Hotfix_2001-09-28.tgz
Patch3: Zope-2.2.5-pcgi-syslog.patch

Obsoletes: Zope-Hotfix-DTML-2000_12_18-1 , Zope-Hotfix-localroles-2000_12_15a-1
## Patch5: Zope-2.2.2-access-log.patch

#----------------------------------------------------------------------
Summary:            An application server and portal toolkit for building Web sites.
Group:              Applications/Internet
Requires:           python >= 1.5.2
%description
The Z Object Programming Environment (Zope) is a free, Open Source[tm]
Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

Brian Lloyd's excellent article, An Introduction to Zope
(http://www.devshed.com/Server_Side/Zope/Intro/) provides a great starting
point to understanding what Zope is and how you can use it.

For a fully functional installation of Zope, install this single huge
package and then _either_ the Zope-zserver RPM, for a minimal Python-based
web server; or the Zope-pcgi RPM, for use with Apache's CGI facility.

If you only want portions of Zope, there are subpackages available
for each subsystem and you should _not_ install this RPM.

#----------------------------------------------------------------------
%package core
Summary:            Central Core of Zope w/General Extensions
Group:              Applications/Internet
Requires:           python >= 1.5.2, Zope-components, Zope-ztemplates, Zope-zpublisher, Zope-services
Provides:           					Zope
Obsoletes: Zope-Hotfix-DTML-2000_12_18-1 , Zope-Hotfix-localroles-2000_12_15a-1
%description core
The Z Object Programming Environment (Zope) is a free, Open Source[tm]
Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

Brian Lloyd's excellent article, An Introduction to Zope
(http://www.devshed.com/Server_Side/Zope/Intro/) provides a great starting
point to understanding what Zope is and how you can use it.

The Zope-core package contains the central core programs and general
extensions needed to run Zope.

For a fully functional installation of Zope, install Zope, Zope-components,
Zope-core, Zope-services, Zope-zpublisher, and Zope-ztemplates, and one of
the following packages: Zope-zserver, for a minimal Python-based Web
server; or Zope-pcgi, for using Zope with Apache's CGI facility.

#----------------------------------------------------------------------
%package components
Summary:            A group of standalone Python binary extension modules.
Group:              Applications/Internet
Requires:           python >= 1.5.2

%description components
The Zope-components package includes a group of standalone Python extension
modules, including BTree, cPickle/cStringIO, ExtensionClass, Acquisition,
MethodObject, MultiMapping, ThreadLock, Missing, Sync, Record,
ComputedAttribute and zlib.  These modules can be used with the Zope
application server and portal toolkit or standalone.

#----------------------------------------------------------------------
%package ztemplates
Summary:            A template for creating dynamic HTML for Zope.
Group:              Applications/Internet
Requires:           python >= 1.5.2

%description ztemplates
The Zope-ztemplates package contains a Python-based template mechanism for
creating dynamic HTML sources, with Python expressions, looping constructs,
etc. The Z Template system can be used with the Zope application server and
portal tookit, or it can be used standalone. Z Template was called
DocumentTemplate in the olden days (before Zope).

#----------------------------------------------------------------------
%package zpublisher
Summary:            An object publishing mechanism for Zope.
Group:              Applications/Internet
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description zpublisher
Zpublisher is a Python-based object publishing mechanism that maps URLs
to an object hierarchy and handles the interface between the Web server
and the Web application, hiding many complex details.  Zpublisher is
used with the Zope application server and portal toolkit, but it can be
used standalone as well.  Zpublisher was called Bobo before Zope came along.


#----------------------------------------------------------------------
%package services
Summary:            Middle-level services for Zope.
Group:              Applications/Internet
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description services
The Zope-services package contains a group of middle-level services needed
by the Zope application server and portal toolkit (but not specifically
tied to Zope). Services included are DateTime, SearchIndex and
StructuredText.


#----------------------------------------------------------------------
%package zserver
Summary:            Initial Object Database/Standalone HTTP Server
Group:              Applications/Internet
Requires:           Zope
Conflicts:          Zope-pcgi
Provides:						Zope-webserver
#Prereq: /etc/init.d 

%description zserver
The Zope-zserver package contains the files needed for setting up a
Zope website, including an empty object database. Zope is an application
server and portal toolkit.

Also included is the ZServer, which is a small, standalone web server
written in Python.  The ZServer uses the very fast Medusa technology
and is multithreaded.  This package comes preconfigured to serve
web pages on port 8080 and ftp access on 8021.  The programmer's port
interface comes disabled for security reasons but can be reenabled.

If you wish to instead run Zope thru Apache, do not use this package
but rather the Zope-pcgi package.  This package is for -standalone-
web serving.

#----------------------------------------------------------------------
%package pcgi
Summary:            Persistent CGI (PCGI) capabilities for Zope.
Group:              Applications/Internet
Requires:           Zope, apache >= 1.3
Conflicts:          Zope-zserver
URL:                http://starship.python.net/crew/jbauer/persistcgi/
Provides:						Zope-webserver
#Prereq: /etc/init.d 

%description pcgi
Persistent CGI (PCGI) is an architecture designed by Digital Creations
(http://www.digicool.com) for publishing Web objects as long-running
server processes in order to improve the performance of serving Web
pages.  This package is PCGI for use with the Zope application server
and portal toolkit.

It is not necessary for ZServer to actually listen for incoming HTTP
requests.  If you want Apache to do the actual listening and serving,
then you can use ZServer's PCGI component to communicate with Apache.

Please note that versions of the Apache Web server prior to 1.3 do not
have a sufficiently implemented rewrite module to provide authentication
for Zope.  You'll need to upgrade your Apache if you're using a version
prior to 1.3.

For PCGI HOWTO information, see:
    http://starship.python.net/crew/jbauer/persistcgi/

#----------------------------------------------------------------------
#NOTWORKINGYET %package zpatterns
#NOTWORKINGYET Summary:            An object publishing mechanism for Zope.
#NOTWORKINGYET Group:              Development/Libraries
#NOTWORKINGYET Requires:           python >= 1.5.2
#NOTWORKINGYET 
#NOTWORKINGYET %description zpatterns
#NOTWORKINGYET ZPatterns is an additional, optional framework that can be added to
#NOTWORKINGYET Zope for an enhanced programming enviroment.


########## 
#
# The following environment variables are automatically defined for use
# in any of the following shell scripts:
#
#   RPM_SOURCE_DIR      { where sources originally reside }
#   RPM_BUILD_DIR       { where sources get unpacked into }
#   RPM_DOC_DIR
#   RPM_OPT_FLAGS
#   RPM_ARCH
#   RPM_OS
#   RPM_ROOT_DIR
#   RPM_BUILD_ROOT      { where final images get placed before packaging }
#   RPM_PACKAGE_NAME
#   RPM_PACKAGE_VERSION
#   RPM_PACKAGE_RELEASE
#
##########

####
# Section: Prep Script (Prepare to Build; Usually Just Unpacking the Sources)
####
%prep
# Create Build Subdirectory and Unpack the Main Tar Ball
%setup -q -n %{name}-%{version}-src

%setup -q -T -D -c -a 1 -n %{name}-%{version}-src/ZopeContentManagersGuide
%setup -q -T -D -c -a 2 -n %{name}-%{version}-src/GuideToDTML
%setup -q -T -D -c -a 3 -n %{name}-%{version}-src/GuideToZSQL
%setup -q -T -D -c -a 10 -n %{name}-%{version}-src/ZopeDevelopersGuide
%setup -q -T -D -c -a 11 -n %{name}-%{version}-src/ZopeAdminGuide
%setup -q -T -D -c -a 13 -n %{name}-%{version}-src
#NOTWORKINGYET %setup -q -T -D -c -a 15 -n %{name}-%{version}-src

# Current Hotfix(es), if Present
%setup -q -T -D -c -a 15 -n %{name}-%{version}-src
# %setup -q -T -D -c -a 16 -n %{name}-%{version}-src
# %setup -q -T -D -c -a 17 -n %{name}-%{version}-src
# %setup -q -T -D -c -a 18 -n %{name}-%{version}-src
# %setup -q -T -D -c -a 19 -n %{name}-%{version}-src
# %setup -q -T -D -c -a 20 -n %{name}-%{version}-src
%setup -q -T -D -c -a 21 -n %{name}-%{version}-src
%setup -q -T -D -c -a 22 -n %{name}-%{version}-src
%setup -q -T -D    -a 4 -n %{name}-%{version}-src

# Reset RPM's Concept of "-n" Back to the Top-Level Package Dir Name
%setup -q -T -D -n %{name}-%{version}-src

%patch3 -p1

## %patch5 -p1

# Create a Temporary Holding Area in the RPM's Build Directory for Docs
mkdir misc

# Some of the docs incorrectly have the 'Execute' bit set on their files
# so we do this for security reasons (and we can't use chmod -R if we
# want to only change files modes and not those of subdirectories) ;-(
find ZopeContentManagersGuide -type f -exec chmod 644 \{\} \;
find GuideToDTML              -type f -exec chmod 644 \{\} \;
find GuideToZSQL              -type f -exec chmod 644 \{\} \;
find Tutorial                 -type f -exec chmod 644 \{\} \;

####
# Section: Builld Script (Actually Perform the Build; Usually Just 'make')
####
%build
  cp %{SOURCE7} $RPM_BUILD_DIR/%{name}-%{version}-src/README.RPM

  echo Building the PCGI Wrapper...
  (cd pcgi
  ./configure --prefix=/usr
  make)

  echo Building Extension Modules...

  # Set up an easily-accessible Makefile template
  cp lib/python/Shared/DC/xml/pyexpat/Makefile.pre.in  Makefile.pre.in

  cp Makefile.pre.in lib/Components/BTree
  cp Makefile.pre.in lib/Components/ExtensionClass
  cp Makefile.pre.in lib/Components/cPickle
  cp Makefile.pre.in lib/Components/zlib

  cp Makefile.pre.in lib/python/DocumentTemplate
  cp Makefile.pre.in lib/python/SearchIndex
  cp Makefile.pre.in lib/python/ZODB

#NOTWORKINGYET   cp Makefile.pre.in lib/python/Products/ZPatterns

  # === General Loadable-Binary-Library Python Components ===

  # BTree.so IIBTree.so IOBTree.so OIBTree.so intSet.so
  (cd lib/Components/BTree
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make CFLAGS="-I../../python/ZODB/ -I/usr/include/python1.5/"
   make clean
  )

  # ExtensionClass.so Acquisition.so MethodObject.so MultiMapping.so
  # ThreadLock.so Missing.so Sync.so Record.so ComputedAttribute.so
  (cd lib/Components/ExtensionClass
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   mkdir ExtensionClass
   mv test_*.py release.* ExtensionClass
   mv COPYRIGHT.txt ExtensionClass.COPYRIGHT.txt
   mv README ExtensionClass.README
  )

  # cStringIO.so cPickle.so
  (cd lib/Components/cPickle
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # zlib.so
  (cd lib/Components/zlib
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # pyexpat.so
  (cd lib/python/Shared/DC/xml/pyexpat
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   rm -rf expat
   mv README   $RPM_BUILD_DIR/%{name}-%{version}-src/misc/pyexpat.README
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # === Zope Add-Ons ===

#NOTWORKINGYET   # DynPersist.so (needs cPersistence.h from ZODB dir; hence must be in this order)
#NOTWORKINGYET   (cd lib/python/Products/ZPatterns
#NOTWORKINGYET    make -f Makefile.pre.in boot PYTHON=/usr/bin/python
#NOTWORKINGYET    make
#NOTWORKINGYET    make clean
#NOTWORKINGYET    rm *.c Makefile* sedscript
#NOTWORKINGYET   )

  # === Zope Subsystems ===

  # cDocumentTemplate.so
  (cd lib/python/DocumentTemplate
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.stx' -exec rm \{\} \;
  )

  # TimeStamp.so cPersistence.so cPickleCache.so winlock.so coptimizations.so
  (cd lib/python/ZODB
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.gif' -not -name '*.html' -not -name '*.stx' -exec rm \{\} \;
  )

  # Splitter.so Query.so
  (cd lib/python/SearchIndex
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # Remove Non-Release Items Before Copying Dirs
  # into Package, to Minimize Package Size

  find lib/python -type f -and \( -name 'Setup' -or -name '.cvsignore' \) -exec rm \{\} \;
  rm ZServer/medusa/monitor_client_win32.py

####
# Section: Install-After-Build Script (Often Just 'make install')
####
%install
  rm -rf $RPM_BUILD_ROOT
  rm -f lib/python/Products/Hotfix_2000-12-15a/README.txt~ || :
  # Make the Necessary Directories
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
  install -m0755 --directory      $RPM_BUILD_ROOT/var/www/html/zopedocs

  # Directory Structure for SOFTWARE_HOME=/usr/share/zope/
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/bin
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/import
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/lib
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/lib/python
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/Extensions
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/utilities
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/share/zope/lib/python/ZODB

  # Directory Structure for INSTANCE_HOME=/var/zope/
  install -m0755 --directory      $RPM_BUILD_ROOT/etc/rc.d/init.d
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope/Extensions
  install -m0711 --directory      $RPM_BUILD_ROOT/var/zope/var
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope/Products
  install -m0775 --directory      $RPM_BUILD_ROOT/var/log
  install -m0775 --directory      $RPM_BUILD_ROOT/usr/share/zope/ZServer

  (cd lib/Components
   install -m0644 ExtensionClass/*.py  $RPM_BUILD_ROOT/usr/lib/python1.5/
   install -s     BTree/*.so           $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     ExtensionClass/*.so  $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     cPickle/*.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
   install -s     zlib/zlib.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
  )

#NOTWORKINGYET   (cd lib/python/Products/ZPatterns
#NOTWORKINGYET    install -s     DynPersist.so        $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload/
#NOTWORKINGYET   )

  install                              $RPM_SOURCE_DIR/%{name}-%{version}-index.html \
                                       $RPM_BUILD_ROOT/var/www/html/zopedocs/index.html

  cp                                   lib/python/Products/ZCatalog/ZCatalog.txt \
                                       $RPM_BUILD_ROOT/var/www/html/zopedocs/

  cp -Rdp ZopeContentManagersGuide/    $RPM_BUILD_ROOT/var/www/html/zopedocs/
  cp -Rdp GuideToZSQL/                 $RPM_BUILD_ROOT/var/www/html/zopedocs/
  cp -Rdp GuideToDTML/                 $RPM_BUILD_ROOT/var/www/html/zopedocs/
  cp -Rdp Tutorial/                    $RPM_BUILD_ROOT/var/www/html/zopedocs/
  cp -Rdp ZopeDevelopersGuide/         $RPM_BUILD_ROOT/var/www/html/zopedocs/
  cp -Rdp ZopeAdminGuide/              $RPM_BUILD_ROOT/var/www/html/zopedocs/

  cp -Rdp ZServer/                     $RPM_BUILD_ROOT/usr/share/zope/
  cp -Rdp utilities/                   $RPM_BUILD_ROOT/usr/share/zope/
  cp -Rdp import/                      $RPM_BUILD_ROOT/usr/share/zope/
  install -m 0755 zpasswd.py           $RPM_BUILD_ROOT/usr/bin/zpasswd
  install -m 0755 zpasswd.py           $RPM_BUILD_ROOT/usr/share/zope/utilities/

  cp Extensions/README.txt             $RPM_BUILD_ROOT/usr/share/zope/Extensions/
  cp Extensions/README.txt             $RPM_BUILD_ROOT/var/zope/Extensions/

  (cd lib/python
   # These are generally useful modules, (relatively) independent of Zope
   for i in DocumentTemplate/ SearchIndex/ ZPublisher/ DateTime/ \
            StructuredText/
   do
      cp -Rdp $i $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   done

   # These are integral parts of Zope and can't really stand alone
   cp    version.txt                   $RPM_BUILD_ROOT/usr/share/zope/lib/python/

   for i in Zope/ AccessControl/ App/ HelpSys/ OFS/ TreeDisplay/ \
            ZClasses/ Shared/ Products/ ZODB/ webdav/ ZLogger/
   do 
      cp -Rdp $i $RPM_BUILD_ROOT/usr/share/zope/lib/python/
   done

   install -m0644 *.py                 $RPM_BUILD_ROOT/usr/share/zope/lib/python/
  )

  # Give ZODB the -particular- version of cPickle that ships with Zope
  install -s lib/Components/cPickle/cPickle.so $RPM_BUILD_ROOT/usr/share/zope/lib/python/ZODB/

  install -m 0755 -s pcgi/pcgi-wrapper  $RPM_BUILD_ROOT/usr/bin/pcgi-wrapper
  install pcgi/pcgi_publisher.py        $RPM_BUILD_ROOT/usr/lib/python1.5/pcgi_publisher.py
  install pcgi/Util/killpcgi.py         $RPM_BUILD_ROOT/usr/lib/python1.5/killpcgi.py

  install                               $RPM_SOURCE_DIR/%{name}-%{version}-pcgi_nullpublisher.py  \
                                        $RPM_BUILD_ROOT/var/zope/pcgi_nullpublisher.py

  # Establish an Empty Zope Object Database
  install -m 0600 var/Data.fs.in        $RPM_BUILD_ROOT/var/zope/var/Data.fs

  # Create a Safe Preowned Zope Logfile, for ZServer
  # (Otherwise a symlink-redirect attack may be possible!)
  touch $RPM_BUILD_ROOT/var/log/zope

  # Declare the Superuser of the Default Zope Project
  python $RPM_BUILD_ROOT/usr/bin/zpasswd -u superuser -p 123 -d localhost $RPM_BUILD_ROOT/var/zope/access
  chmod 0600 $RPM_BUILD_ROOT/var/zope/access

  install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT/etc/rc.d/init.d/zope
  install -m 0755 %{SOURCE6} $RPM_BUILD_ROOT/var/zope/Zope.cgi
  install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT/var/zope/zserver_wo_pcgi.sh
  install -m 0755 %{SOURCE9} $RPM_BUILD_ROOT/var/zope/zserver_w_pcgi.sh
  install -m 0755 z2.py      $RPM_BUILD_ROOT/var/zope/z2.py

  # Precompile Python Source for Faster Imports During Usage
  # (Since user of package may not have write-access to install directory)
  python -O /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5
  python    /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5

  python -O /usr/lib/python1.5/compileall.py    -d /usr/share/zope/     $RPM_BUILD_ROOT/usr/share/zope
  python    /usr/lib/python1.5/compileall.py    -d /usr/share/zope/     $RPM_BUILD_ROOT/usr/share/zope

  # Remove Duplicate Documentation Embedded in Python Package Dirs
  (cd $RPM_BUILD_ROOT/usr/share/zope
   rm     lib/python/AccessControl/AccessControl.txt
   rm     lib/python/Products/ZCatalog/ZCatalog.txt
#   rm     ZServer/{INSTALL,README}.txt
  )
  (cd $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
   rm     DateTime/DateTime.html
   rm     DocumentTemplate/Let.stx
   rm -rf StructuredText/regressions/
  )

#  rm -rf $RPM_BUILD_ROOT/usr/share/zope/lib/python/Products/ZPatterns

#NOTWORKINGYET   (cd $RPM_BUILD_ROOT
#NOTWORKINGYET    find usr/share/zope/lib/python \
#NOTWORKINGYET   	-path usr/share/zope/lib/python/Products/ZPatterns -prune \
#NOTWORKINGYET 	-o -print | sed -e "s#^#/#" > /tmp/zcores
#NOTWORKINGYET    cat /tmp/zcores
#NOTWORKINGYET   )

####
# Section: Delivery Install/Uninstall Scripts (Pre/Post Install/Erase Scripts)
####

%pre zserver
  /usr/sbin/useradd -o -r -M -s /bin/bash -d /var/zope -c "Zope Server" zope >/dev/null 2>&1

%pre pcgi
  /usr/sbin/useradd -o -r -M -s /bin/bash -d /var/zope -c "Zope Server" zope >/dev/null 2>&1

%post
  # Remove troublesome obsolete file that many people have lying about
  rm -f /usr/lib/python1.5/ComputedAttribute.py

%post zserver
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_wo_pcgi.sh /var/zope/zserver.sh
  ln -sf /usr/share/zope/import /var/zope/import

%post pcgi
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_w_pcgi.sh /var/zope/zserver.sh
  ln -sf /usr/share/zope/import /var/zope/import

%post core
  # Remove troublesome obsolete file that many people have lying about
  rm -f /usr/lib/python1.5/ComputedAttribute.py

%preun zserver
  if [ "$1" = 0 ] ; then
    /etc/rc.d/init.d/zope stop > /dev/null 2>&1
    /sbin/chkconfig --del zope
    if [ /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    if [ /usr/share/zope/import -ef /var/zope/import ]; then
      rm /var/zope/import
    fi
  fi

%preun pcgi
  if [ "$1" = 0 ] ; then
    /etc/rc.d/init.d/zope stop > /dev/null 2>&1
    /sbin/chkconfig --del zope
    if [ /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    if [ /usr/share/zope/import -ef /var/zope/import ]; then
      rm /var/zope/import
    fi
  fi

%postun zserver
  if [ $1 = 0 ] ; then
	userdel zope >/dev/null 2>&1 || :
  fi
  if [ "$1" -ge "1" ]; then
	/etc/rc.d/init.d/lpd condrestart > /dev/null 2>&1
  fi

%postun pcgi
  if [ $1 = 0 ] ; then
	userdel zope >/dev/null 2>&1 || :
  fi
  if [ "$1" -ge "1" ]; then
	/etc/rc.d/init.d/lpd condrestart > /dev/null 2>&1
  fi

####
# Section: Verify Script (Check for Proper Installation of Package)
####

%verifyscript zserver
  if [ ! /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_wo_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

  if [ ! /usr/share/zope/import -ef /var/zope/import ]; then
    echo "/usr/share/zope/import should be linked to /var/zope/import" >&2
  fi

%verifyscript pcgi
  if [ ! /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_w_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

  if [ ! /usr/share/zope/import -ef /var/zope/import ]; then
    echo "/usr/share/zope/import should be linked to /var/zope/import" >&2
  fi

####
# Section: Clean Script (Tidy Up Build Area After a Build Completes)
####
%clean
  rm -rf $RPM_BUILD_ROOT

####
# Section: Files (List of Files w/Attributes Making Up Package)
####

# Note: the root package of just Zope (w/o any -<stuff>) includes all
#       of the Zope release, for those who want to quickly install
#       everything.  The release is also packaged as separate subpackages
#       for those who want to be more selective.

#%files -f /tmp/zcores
%files
  %defattr(-, root, root)

  #-- Copy of Zope-core Contents:
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc /var/www/html/zopedocs/index.html
  %doc /var/www/html/zopedocs/ZopeContentManagersGuide
  %doc /var/www/html/zopedocs/GuideToZSQL
  %doc /var/www/html/zopedocs/Tutorial
  %doc /var/www/html/zopedocs/ZopeDevelopersGuide
  %doc /var/www/html/zopedocs/ZopeAdminGuide
  %doc /var/www/html/zopedocs/ZCatalog.txt
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/share/zope/lib/python/

  /usr/share/zope/Extensions/
  /usr/bin/zpasswd

  #-- Copy of Zope-components Contents:
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
#OBSOLETE  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py
  /usr/lib/python1.5/AqAlg.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cStringIO from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so

  #-- Copy of Zope-zpublisher Contents:
  /usr/lib/python1.5/site-packages/ZPublisher/

  #-- Copy of Zope-ztemplates Contents:
  %doc lib/python/DocumentTemplate/Let.stx
  %doc /var/www/html/zopedocs/GuideToDTML
  /usr/lib/python1.5/site-packages/DocumentTemplate/

  #-- Copy of Zope-services Contents:
  %doc lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files core
  %defattr(-, root, root)
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc /var/www/html/zopedocs/index.html
  %doc /var/www/html/zopedocs/ZopeContentManagersGuide
  %doc /var/www/html/zopedocs/GuideToZSQL
  %doc /var/www/html/zopedocs/Tutorial
  %doc /var/www/html/zopedocs/ZopeDevelopersGuide
  %doc /var/www/html/zopedocs/ZopeAdminGuide
  %doc /var/www/html/zopedocs/ZCatalog.txt
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/share/zope/lib/python/

  /usr/share/zope/Extensions/
  /usr/bin/zpasswd

%files components
  %defattr(-, root, root)
  %doc LICENSE.txt
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
#OBSOLETE  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py
  /usr/lib/python1.5/AqAlg.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cStringIO from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so

%files zpublisher
  %defattr(-, root, root)
  %doc LICENSE.txt
  /usr/lib/python1.5/site-packages/ZPublisher/

%files ztemplates
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DocumentTemplate/Let.stx
  %doc /var/www/html/zopedocs/GuideToDTML
  /usr/lib/python1.5/site-packages/DocumentTemplate/

%files services
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files zserver
  %defattr(-, root, root)
  %doc LICENSE.txt  ZServer/INSTALL.txt  ZServer/README.txt
  /usr/share/zope/ZServer/
  /usr/share/zope/utilities/
  /usr/share/zope/import/

  %config                             /etc/rc.d/init.d/zope
  %config(noreplace) %attr(600, root, root)      /var/zope/access
  %config                             /var/zope/z2.py
  %config                             /var/zope/zserver_wo_pcgi.sh

  # IMPORTANT: ZServer runs as user 'zope' and
  #            must have r/w access to the var/ directory
  #            so that it can create temp and index files.
  %defattr(-, zope, root)
  %dir                                /var/zope/
  %dir                                /var/zope/Products
  %dir                                /var/zope/var/
                                      /var/zope/Extensions/
  %config(noreplace) %verify(not size md5 mtime) /var/zope/var/Data.fs
  %verify(not size md5 mtime)         /var/log/zope

%files pcgi
  %defattr(-, root, root)
  %doc LICENSE.txt  pcgi/README  ZServer/README.txt  ZServer/INSTALL.txt
  %doc pcgi/Example/  pcgi/Test/  pcgi/Util/

  /usr/bin/pcgi-wrapper
  /usr/lib/python1.5/pcgi_publisher.py
  /var/zope/pcgi_nullpublisher.py
  /usr/lib/python1.5/killpcgi.py
  /usr/share/zope/ZServer/
  /usr/share/zope/utilities/
  /usr/share/zope/import/

  %config                             /etc/rc.d/init.d/zope
  %config(noreplace) %attr(600, root, root) /var/zope/access
  %config                             /var/zope/z2.py
  %config                             /var/zope/zserver_w_pcgi.sh
                                      /var/zope/Zope.cgi

  # IMPORTANT: PCGI runs as user 'zope' and must have r/w
  #            access to the var/ directory so that it can
  #            create temp and index files.  ZServer runs as
  #            user 'zope' and must have write access to var.
  %defattr(-, zope, root)
  %dir                                /var/zope/
  %dir                                /var/zope/Products
  %dir                                /var/zope/var/
                                      /var/zope/Extensions
  %config(noreplace) %verify(not size md5 mtime) /var/zope/var/Data.fs
  %verify(not size md5 mtime)         /var/log/zope

#NOTWORKINGYET %files zpatterns
#NOTWORKINGYET   %defattr(-, root, root)
#NOTWORKINGYET   /usr/share/zope/lib/python/Products/ZPatterns
#NOTWORKINGYET 
#NOTWORKINGYET   # ZPatterns Helper Module:
#NOTWORKINGYET   /usr/lib/python1.5/lib-dynload/DynPersist.so

%changelog
* Fri Oct  5 2001 Tim Powers <timp@redhat.com>
- fixed preun scripts so that Zope really shuts down during an uninstall
- fixed initscript so that condrestart really exists

* Tue Oct  2 2001 Tim Powers <timp@redhat.com>
- added Hotfix_2001-09-28.tgz

* Wed May  2 2001 Tim Powers <timp@redhat.com>
- applied Hotfix-2001-05-01 to fix a security problem with ZClasses.

* Mon Mar  5 2001 Tim Powers <timp@redhat.com>
- fixed bad group

* Mon Feb 26 2001 Tim Powers <timp@redhat.com>
- added Hotfix_2001-02-23 to the mix

* Tue Jan 23 2001 Tim Powers <timp@redhat.com>
- updated initscript

* Fri Jan 12 2001 Tim Powers <timp@redhat.com>
- updated to 2.2.5
- dropped the hotfix sources since the things they fixed are included
  in the 2.2.5 version of Zope

* Thu Jan  4 2001 Tim Powers <timp@redhat.com>
- fixed vendor for rpmlint

* Tue Jan  2 2001 Tim Powers <timp@redhat.com>
- added in the latest Zope-Hotfix sources, and obsoleted the hotfix
  packages they were a part of

* Tue Dec 12 2000 Tim Powers <timp@redhat.com>
- updated the docs so that the rules for the httpd.conf file are accurate (ie.
  they work) and also the steps which must occur for the login and password
  for the administrator's access.

* Mon Dec 11 2000 Tim Powers <timp@redhat.com>
- updated the docs to point to /var/www instead of /home/httpd

* Sun Dec 10 2000 Tim Powers <timp@redhat.com>
- built for Powertools 7, using /var/www instead of /home/httpd for html

* Sun Dec 10 2000 Tim Powers <timp@redhat.com>
- built for 6.x, not using /var/www for Zope, using the old /home/httpd
  location for html

* Sat Dec  9 2000 Tim Powers <timp@redhat.com>
- updated to 2.2.4
- added 12-08 hotfix

* Sun Oct 16 2000 Jeff Rush <jrush@taupro.com>
  bumped to zope 2.2.2; added Hotfixes  2000-10-02 and 2000-10-11.

* Sun Aug 27 2000 Jeff Rush <jrush@taupro.com>
  bumped to zope 2.2.1; removed no-longer-needed Hotfix_2000-08-17

* Tue Aug 22 2000 Jeff Rush <jrush@taupro.com>
- added Hotfix_2000-08-17
- temporarily removed /etc/init.d (RH7.0) until I figure out how
  to support both RH6.x *and* RH7.0 in the same RPM. <sigh>
- removed troublesome/obsolete ComputedAttribute.py

* Sun Jul 16 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.2.0; removed no-longer-needed Hotfix-06_16_2000

* Thu Jul 06 2000 Tim Powers <timp@redhat.com>
- fixed PreReq to PreReq /etc/init.d
- added Hotfix-06_16_2000
 
* Thu Jun 15 2000 Preston Brown <pbrown@redhat.com>
- moved init script, added condrestart directive
- auto stop/restart service on upgrades

* Thu Jun 1 2000 Tim Powers <timp@redhat.com>
- fixed so that it's no longer putting files into /home, instead they are
  going into /var/www (FHS compliant).

* Mon May 22 2000 Tim Powers <timp@redhat.com>
- built for 7.0, thanks Jeff!

* Fri Apr 28 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.6

* Sun Mar 12 2000 Jeff Rush <jrush@taupro.com>
- added zpasswd.py back in, since my rename to just zpasswd confused some.
  both are now present in the RPM, for all audiences.
- modified the README.RPM re the section about Apache rewrite rules; I
  discussed and removed the trailing slash, the presence of which causes
  Zope to reject attempts to delete objects in the root folder.

* Thu Feb 26 2000 Jeff Rush <jrush@taupro.com>
- 2.1.4-1 Release on Zope.org site
- bumped to zope 2.1.4
- changed Zope-core to provide 'Zope', to satisfy zserver and pcgi subpkgs.

* Fri Jan 14 2000 Tim Powers <timp@redhat.com>
- added Provides lines to Zope-pcgi and Zope-zserver so that addon packages
	such as Squishdot have something useful to require.

* Thu Jan 13 2000 Tim Powers <timp@redhat.com>
- built for Powertools 6.2

* Thu Jan 11 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.2
- folded in Jonathan Marsden <jonathan@xc.org> Changes (many below)
- used zpasswd.py to generate initial pw in encrypted form.
- fixed syslog logging in various ways, and re-enabled it, for both
-    ZServer AND pcgi-wrapper.
- fixed /etc/rc.d/init.d/zope to be consistent about pid file.
- fixed /etc/rc.d/init.d/zope to use RH killproc function.
- added 'noreplace' so that Zope database and access file are retained
-    on an RPM upgrade.
- patched PCGI to support syslog logging, and then default to it.
- patched ZServer/Medusa to properly support syslog logging.
- added a user 'zope' and made many zope files/dirs owned by it.
- cleaned up pcgi-wrapper's msg about can't find ZServer, since it is
-    one of the most common errors.  It now explains what it is doing.
- moved all *.{pid,soc} files into /var/run, to cleanly separate ownership
-    issues in /var/zope hierarchy for user 'zope' and user 'nobody'.

* Mon Jan 03 2000 Jeff Rush <jrush@taupro.com>
- bumped to zope 2.1.1
- added to /etc/rc.d/init.d/zope code to correctly kill the process specified
-    in /var/zope/pcgi.pid
- changed permissions on /var/zope/access such that only root can read/write
-    it, to protect the Zope superuser password.

* Sat Nov 29 1999 Jeff Rush <jrush@taupro.com>
- changed ownership on /var/zope/access from nobody.nobody to root.root.

* Sat Nov 20 1999 Jeff Rush <jrush@taupro.com>
- updated to zope 2.1.0beta2
- fixed permissions/ownership on /var/zope/access to be more secure (600).
- removed pypath.patch, as those changes got into the zope distribution.

* Tue Nov 2 1999 Jeff Rush <jrush@taupro.com>
- added accidentally omitted /usr/bin/zpasswd to the RPM output.
- clarified wording re use of zpasswd in README.RPM file.
- added "-u nobody" to both zserver_*.sh files, for clarity of intent;
-    it already ran as nobody by default, but some people worried.

* Wed Oct 27 1999 Jeff Rush <jrush@taupro.com>
- fixed /etc/rc.d/init.d/zope file to *NOT* delete /var/zope/zserver.pid
- fixed /var/zope/Zope.cgi to use PCGI_PUBLISHER=/var/zope/pcgi_nullpublisher.py,
-    so that when the PCGI wrapper can't find ZServer, it won't try to start one
-    and generate bogus error messages, because PCGI doesn't do it right.
- fixed /var/zope/zserver.sh to NOT specify syslog-style logging, since under
-    Red Hat 6.1, the syslog daemon no longer listens to the port we expected.

* Sat Sep 25 1999 Jeff Rush <jrush@taupro.com>
- updated documents ZCMG, ZSQL and ZDTML to Sep 24th 1999 versions
- added empty directories /var/zope/{import,Extensions}
- relocated zope from /usr/lib/python1.5/site-packages/ZopeWorld/
-    to /usr/share/zope/
- added user zope, for better security control

* Fri Sep 17 1999 Jeff Rush <jrush@taupro.com>
- updated sources to minor (security fix) release 2.0.1

* Fri Sep 10 1999 Jeff Rush <jrush@taupro.com>
- heavily reworked spec file for 2.0.0

* Thu Sep 9 1999 Tim Powers <timp@redhat.com>
- updated sources to 2.0.0
- _major_ spec file cleanups
- merged patch from src.rpm authored by Andreas Kostyrka <andreas@mtg.co.at>
- borrowed some things from Andreas Kostyrka's spec file

* Mon Aug 30 1999 Tim Powers <timp@redhat.com>
- changed groups

* Tue Aug 17 1999 Tim Powers <timp@redhat.com>
- chown permissions on some files in /var/local for the pcgi package

* Mon Aug 2 1999 Tim Powers <timp@redhat.com>
- changed buildroot to be in /var/tmp instead of /tmp
- rebuilt for 6.1

* Mon Jul 21 1999 Jeff Rush <jrush@taupro.com>
- Added in accidently omitted SearchIndex/{Query,Splitter}.so

* Tue Jul 6 1999 Tim Powers <timp@redhat.com>
- started changelog
- cleaned up spec file
- built for powertools

* Mon Jun 24 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.10.3

* Mon Jun 23 1999 Jeff Rush <jrush@taupro.com>
- Added /etc/rc.d/init.d/zope and reworked scripts

* Tue Mar 1 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.10.2

* Wed Jan 29 1999 Jeff Rush <jrush@taupro.com>
- Updated to 1.9.0 Final Release

* Wed Dec 9 1998 Jeff Rush <jrush@taupro.com>
- Original 1.9beta1 Release

